// twippera.js

var Twippera = {
    version : '20071029-1',
    release : 30,
    TID     : null,
    XHRID   : null,
    postMsgs : [],
    PMindx  : 0,
    timeout : 30000,
    fcount : 0
}
    Twippera.initEvent = function() {
        var self = this;
        var locale = self.config.locale;

        $('header').addEventListener('dblclick', function() {
            self.foldMsgList();
        }, false);

        $('reload').addEventListener('click', function(){
            if(self.ear == 'true') {
                self.autoReflesh();
            } else {
                self.post("friends_timeline");
            }
            if(Widget.getValue('state') == 'back') {
                self.flipWidget('front');
            } 
        }, false);

        $('pref').addEventListener('click', function() {
            if(Widget.getValue('state') == 'front') {
                self.flipWidget('back');
            } else {
                self.flipWidget('front');
            }
        }, false);
        
        $('close').addEventListener('click', function() {
            window.close();
        }, false);

        $('post').addEventListener('click', function() {
            self.post('update');
        }, false);

        $('save').addEventListener('click', function() {
            self.config.init();
        }, false);

        $('about').addEventListener('click', function() {
            self.showPopup(
                '<h2>'+SPLangs.about[locale]+'</h2>' +
                '<p><span>' + SPLangs.version[locale] +'</span>: ' + 
                self.version + ' (<a href="http://widgets.opera.com/widget/6522">' +
                SPLangs.download[locale] +
                '</a>)</p>' +
                '<p>' + SPLangs.author[locale] +
                ': <a href="http://higeorange.com/">Higeorange</a> (<a href="http://twitter.com/higeorange">Twitter</a>)</p>' +
                '<p>' + SPLangs.design[locale] + ': tobetchi (<a href="http://twitter.com/tobetchi">Twitter</a>)</p>' +
                '<h3>' + SPLangs.trans[locale] + '</h3>' +
                '<ul><li>Español: Eduardo Escárez</li>' +
                '<li>Magyor: Tamás Zahola</li>' +
                '<li>Lietuviškai: Gediminas Ryženinas</li>' +
                '<li>Ðóññêèé: Andrew Ustimov</li>' +
                '<li>Italiano: Alberto Raffaele Casale</li>' +
                '<li>Português: Eduardo Medeiros Schutt</li>' +
                '<li>简体中文: Jimmy Lvo</li>' +
                '</ul>',
                SPLangs.close[locale],
                null
            )
        }, false);

        $('pclose').addEventListener('click', function() {
            self.hidePopup();
        }, false);

        $('status').addEventListener('keyup', function(evt) {
            var status = $('status').value
            var rest   = 140 - status.length;
            $('count').innerHTML = (rest >= 0) ? rest : 0;
        }, false);

        $('query').addEventListener('keyup', function(evt) {
            var query = $('query').value;
            self.cache.updateCond(function(c) {
                return c["usr"].indexOf(query) > -1;
            });
        }, false);

        new KeyBinds($('status'), {
            "Up": function(evt) {
                if(self.postMsgs[self.PMindx + 1] && !evt.shiftKey) {
                    self.showPostHistory('back');
                }
            },
            "Down": function(evt) {
                if(self.postMsgs[self.PMindx - 1] && !evt.shiftKey) {
                    self.showPostHistory('forward');
                }
            }
        }).load();

        new KeyBinds(document, {
            "C-u": function() {
                if(window.getComputedStyle($('searchField'), null).display == "block") {
                    $('query').blur();
                    $('searchField').style.display = "none";
                    self.cache.parse(self.cache.list);
                } else {
                    $('query').value = "";
                    $('query').focus();
                    $('searchField').style.display = "block";
                }
            },
            "C-f": function() {
                if(Widget.getValue('state') == 'front') {
                    self.flipWidget("back");
                } else {
                    self.flipWidget('front');
                }
            },
            "C-r": function() {
                self.post('friends_timeline');
            },
            "C-m": function() {
                self.foldMsgList();
            }//,
//            "C-t": function() {
//                opera.postError("tome");
//                self.cache.updateCond(function(c) {
//                    return c["class"] == "tome";
//                });
//            }
        }).load();
    };

    Twippera.showPostHistory = function(to) {
        var status = $('status')
        if(to == 'back') {
            if(this.PMindx == 0) {
                this.postMsgs[0] = { msg: $('status').value, post: 0 };
            }
            this.PMindx += 1;
        } else if (to == 'forward') {
            this.PMindx -= 1;
        }
        status.value = this.postMsgs[this.PMindx].msg;
        setCaretPosition(status, status.value.length);
    };

    Twippera.foldMsgList = function() {
        switch (Widget.getValue('list')) {
            case "show":
                $('updateList').style.height = '0'
                Widget.setValue('hide', 'list');
                break;
            case "hide":
                $('updateList').style.height = '280px'
                Widget.setValue('show', 'list');
                break;
            default:
                break;
        }
    };

    // from my.opera sample widget
    Twippera.flipWidget = function(to) {
        switch (to) {
            case "back":
                $('front').style.display  = "none";
                $('config').style.display = "block";
                Widget.setValue('back', 'state');
                break;
            case "front":
                $('front').style.display  = "block";
                $('config').style.display = "none";
                Widget.setValue('front', 'state');
                break;
            default:
                break;
        }
    };

    Twippera.selectMessage = function() {
        var sc = $('updateList').scrollTop;
        var divs = $('updateList').getElementsByTagName('li');

        var top_offset = $('updateList').offsetTop;
        var len = divs.length;
        if(!len) return;
        var offsets = [];
        for(var i = 0; i < len; i++) {
            offsets.push(divs[i].offsetTop - top_offset);
        }Vk
    },
    Twippera.nextMessage = function() {
    },
    Twippera.prevMessage = function() {
    }

    Twippera.reply = function(user) {
        var status   = $('status');
        var msg = status.value;
            status.value = '@' + user + ' ' + msg;
        setCaretPosition(status, status.value.length);
    };

    Twippera.autoReflesh = function() {
        clearTimeout(this.TID);
        var self = this;
        this.post("friends_timeline");
        this.TID = setTimeout(function(){ self.autoReflesh() }, Twippera.config.time);
    };

    Twippera.post = function(type) {
        var self = this;
            self.hidePopup();
        var config = Twippera.config;
        var locale = config.locale;
        var status = "";
        var query = null;
        $('reload').style.backgroundImage = 'url("images/loading.gif")';
        if(type == 'update') {
            status = $('status').value;
            if(status == "") return;
            query = 'status=' + status.replace(/(&|\+|\*|;)/g,
                function($0, $1) {
                    return encodeURIComponent($1);
                }
            ) + '&source=Twippera';
            $('status').value = "";
            if(self.postMsgs[0]) {
                if(!self.postMsgs[0].post) {
                    self.postMsgs.shift();
                }
            }
            self.postMsgs.unshift({msg: "", post : 0}, {msg: status, post: 1});
            self.PMindx = 0;
        } else {
            if(this.fcount > 4) {
                self.favorite.check();
                this.fcount = 0;
            } else {
                this.fcount++;
            }
        }

        var xhr = new XMLHttpRequest();
            xhr.open('POST', 'http://twitter.com/statuses/' + type +'.json', true, config.user, config.pass);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            self.XHRID = setTimeout(function(){ 
                if(xhr.readyState == 0 || xhr.readyState == 4) return;
                xhr.abort();
                self.showPopup(
                    SPLangs.timeout[locale],
                    SPLangs.close[locale],
                    null
                );
                $('reload').style.backgroundImage = 'url("images/reload.gif")';
                clearTimeout(self.XHRID);
            }, this.timeout);
            xhr.onreadystatechange = function() {
                if(xhr.readyState == 4 && xhr.status == 200){
                    clearTimeout(self.XHRID);
                    if(type == 'friends_timeline') {
                        self.cache.update(xhr.responseText);
                    } else if(type == 'update') {
                        self.cache.update('[' + xhr.responseText + ']');
                    }
                    $('reload').style.backgroundImage = 'url("images/reload.gif")';
                    status = $('status').value;
                    var rest   = 140 - status.length;
                    $('count').innerHTML = (rest >= 0) ? rest : 0;
                }
            }
            xhr.send(query);
    };
    Twippera.destroy = function(id) {
        var config = Twippera.config;
        var api_url = "http://twitter.com/statuses/destroy/" + id + ".json"
        var xhr = new XMLHttpRequest();
            xhr.open('POST', api_url, true, config.user, config.pass);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.send("");
            xhr.onreadystatechange = function() {
                if(xhr.readyState == 4 && xhr.status == 200){
                    opera.postError(xhr.responseText);
                    $(id).parentNode.removeChild($(id));
                    Twippera.cache.remove(id);
                }
            }
    }

    Twippera.config = {
        user    : "",
        pass    : "",
        locale  : "en",
        time    : ""
    };
    Twippera.config.init = function() {
        var user = $('user').value;
        var pass = $('pass').value

        this.username = user;
        this.password = pass;
        Widget.setValue(user, 'user');
        Widget.setValue(pass, 'pass');

        if($('sar').checked) {
            var time = parseInt($('reflesh').value) * 1000 * 60;
            Widget.setValue("true", "enableReflesh");
            Widget.setValue(time, "time");
        } else {
            Widget.setValue("false", "enableReflesh");
            clearTimeout(this.TID);
        }

        var timeout = parseInt($('timeout').value) * 1000;
        Widget.setValue(timeout, 'timeout');

        var localeSel = $("locale");
        var locale = localeSel.options[localeSel.selectedIndex].value;
        Widget.setValue(locale, "locale");

        this.load();
        Twippera.flipWidget('front');
    };
    Twippera.config.load = function() {
        Widget.setValue('front', 'state');
        Widget.setValue('show', 'list');
        this.locale = Widget.getValue("locale") || "en";
        $('locale').selectedIndex = localeIndex[this.locale];
        this.setLocale(this.locale);
        this.user = Widget.getValue('user');
        this.pass = Widget.getValue('pass');
        this.time = Widget.getValue('time');
        this.ear  = Widget.getValue('enableReflesh');
        this.timeout = Widget.getValue('timeout', 'Number')

        $('count').innerHTML = '140';

        if(this.user != "" && this.pass !="") {
            $('user').value = this.user;
            $('pass').value = this.pass;

            if(Twippera.fcount > 4) {
                Twippera.favorite.check();
                Twippera.fcount = 0;
            } else {
                Twippera.fcount++;
            }

            if(this.ear == "true") {
                $("sar").checked = true;
                $("reflesh").value = this.time / 60000; 
                Twippera.autoReflesh(this.time);
            } else {
                $("sar").checked = false;
                Twippera.post('friends_timeline');
            }
            $('timeout').value = this.timeout / 1000;
        } else {
            Twippera.flipWidget("back");
        }
    };
    Twippera.config.setLocale = function(lng) {
        var lang = Langs[lng];
        var save = $('save');
        for(var i in lang) {
            $(i).innerHTML = lang[i];
        }
    };

    Twippera.cache = {
        list : []
    };
    Twippera.cache.update = function(txt) {
        var config = Twippera.config;
        eval('var json=(' + txt + ')');

        // [{"id":,"created_at":,"text":,"user":{"name":,"profile_image_url":,"description":,"location":,"url":,"id":,"protected":,"screen_name":}},.....]
        for(var i = 0, tmp = [], cl = null, len = json.length; i < len; i++) {

            if(this.check(json[i]['id'])) {
                if(json[i]['text'].indexOf('@' + config.user) >= 0) {
                    cl = 'tome';
                } else if (json[i]['user']['screen_name'] == config.user) {
                    cl = 'myself';
                } else {
                    cl = null;
                }
                tmp.push({
                    id     : json[i]['id'],
                    img    : json[i]['user']['profile_image_url'],
                    usr    : json[i]['user']['screen_name'],
                    msg    : json[i]['text'],
                    time   : json[i]['created_at'],
                    class  : cl,
                    prot   : json[i]['user']['protected'],
                    cached : 0
                });
            }

        }
        if(this.list.length == 0) {
            this.list = tmp;
        } else {
            this.list = tmp.concat(this.list);
        }
        this.sort();
        this.parse(this.list);
    };
    Twippera.cache.remove = function(id) {
        for(var i = 0, list = this.list; i < list.length; i++) {
            if(id == list[i]["id"]) {
                list.splice(i, 1);
                break;
            }
        }
    }
    Twippera.cache.sort = function() {
        for(var i = 0, list = this.list, end = list.length - 1; i < end; i++) {
            for(var j = i + 1; j <= end; j++){
                if(list[i]['id'] < list[j]['id']) {
                    var tmp = list[i];
                    list[i] = list[j];
                    list[j] = tmp
                }
            }
        }
        this.list = list;
    };
    Twippera.cache.updateCond = function(cond /*function*/) {
        var list = [];
        var c = this.list;
        for(var i = 0, len = c.length; i < len; i++) {
            if(cond(c[i])) {
                list.push(c[i]);
            }
        }
        this.parse(list);
    }
    Twippera.cache.check = function(id) {
        for(var c = true, i = 0, len = this.list.length; i < len; i++) {
            if(this.list[i]['id'] == id) {
                c = false;
                break;
            }
        }
        return c;
    };
    Twippera.cache.parse = function(msgs) {
        var list = [];
        for(var i = 0, len = msgs.length, usr; i < len; i++) {
            usr = msgs[i];

            var li = document.createElement('li');
                li.id = usr['id']
            if(usr['class']) {
                li.className = usr['class'];
            }
            if(i % 2 != 0) {
                appendClass(li, "zebra");
            }

            var img = document.createElement('img');
                img.src = usr['img'];
                img.setAttribute('alt', usr['usr']);
                img.style.width = '16px';
                img.style.height = '16px';
                img.setAttribute('onclick', "Twippera.reply('" + usr['usr'] + "')");

            var user = document.createElement('span');
                user.className = 'user';
                user.appendChild(document.createTextNode(usr['usr']));
                user.setAttribute('onclick', "widget.openURL('http://twitter.com/" + usr['usr'] + "')");

                li.appendChild(document.createTextNode(' '));
                li.appendChild(img);
                li.appendChild(user);
                li.appendChild(document.createTextNode(' : '));

            var msg = document.createElement('span');
                msg.className = 'msg';
            if(usr.cached) {
                msg.innerHTML = usr['msg'];
            } else {
                var tmpMsg = Tools.createHTML(usr['msg']);
                msg.innerHTML = tmpMsg;
                usr['msg'] = tmpMsg;
                usr['cached'] = 1;
            }
                li.appendChild(msg);

            var meta = document.createElement('span');
                meta.className = 'meta';

            var time = document.createElement('span');
                time.className = 'post_time';

            var toTwitter = document.createElement('a');
                toTwitter.href = 'http://twitter.com/' + usr['usr'] + '/statuses/' + usr['id'];
                toTwitter.innerHTML = Tools.createTime(usr['time'], Twippera.config.locale);

                time.appendChild(toTwitter)
                meta.appendChild(time);

                if(usr['class']) {
                    if(usr['class'].indexOf('myself') > -1) {
                        var trash = document.createElement('span');
                            trash.className = 'trash';
                            trash.innerHTML = "&nbsp;&nbsp;&nbsp;"
                            trash.setAttribute("onclick", "Twippera.destroy(" + usr['id'] + ")");
                        meta.appendChild(trash);
                    }
                }
                if(usr['prot']) {
                    var protect = document.createElement('span');
                        protect.className = 'protected';
                        protect.innerHTML = "&nbsp;&nbsp;"
                    meta.appendChild(protect);
                }

            var fav = document.createElement('span');
                fav.className = 'fav';
            if(Twippera.favorite.isFavorite(usr['id'])) {
                fav.style.backgroundImage = 'url("images/icon_star_full.gif")';
            } else {
                fav.style.backgroundImage = 'url("images/icon_star_empty.gif")' ;
            }
                fav.setAttribute("onclick", "Twippera.favorite.toggle(this, " + usr['id'] + ")");
                fav.innerHTML = "&nbsp;&nbsp;&nbsp;" // 星がくずれる
                meta.appendChild(fav);

                li.appendChild(meta);

            list.push(li.outerHTML);
        }
        $('updateList').innerHTML = list.join('');
    };

    Twippera.favorite = {
        favorites : []
    };
    Twippera.favorite.check = function() {
        var self = this;
        var config = Twippera.config
        var url = 'http://twitter.com/favorites.json';
        var xhr = new XMLHttpRequest();
            xhr.open("GET", url, false, config.user, config.pass)
            xhr.send(null);
            if(xhr.readyState == 4 && xhr.status == 200) {
                var json = eval(xhr.responseText);
                for(var i = 0, len = json.length; i < len; i++) {
                    if(!self.isFavorite(json[i]['id'])) { 
                        self.favorites.push(json[i]['id']);
                    }
                }
            }
    };
    Twippera.favorite.isFavorite = function(id) {
        return this.favorites.contains(id);
    };
    Twippera.favorite.toggle = function(elm, id){
        var curImage = elm.style.backgroundImage;
        var self = this;
        var url;
        var c = false;

        elm.style.backgroundImage = "url('images/icon_throbber.gif')";

        if(this.isFavorite(id)) {
            url = 'http://twitter.com/favourings/destroy/' + id;
            c = true;
        } else {
            url = 'http://twitter.com/favourings/create/' + id;
        }
        var xhr = new XMLHttpRequest();
            xhr.open("GET", url, true, this.user, this.pass);
            xhr.send(null);
            xhr.onreadystatechange = function() {
                if(xhr.readyState == 4 && xhr.status == 200) {
                    if(c) {
                        self.favorites = self.favorites.del(id);
                        elm.style.backgroundImage = "url('images/icon_star_empty.gif')";
                    } else {
                        elm.style.backgroundImage = "url('images/icon_star_full.gif')";
                        self.favorites.push(id);
                    }
                } else {
                    elm.style.backgroundImage = curImage;
                }
            }
    };

    Twippera.update = {
        url : 'http://opera.higeorange.com/misc/twippera/twipperaRelease.txt'
    }
    Twippera.update.check = function() {
        var self = this;
        var locale = Twippera.config.locale;
        var xhr = new XMLHttpRequest();
            xhr.open('GET', this.url);
            xhr.onreadystatechange = function() {
                if(xhr.readyState == 4 && xhr.status == 200) {
                    var t = xhr.responseText.split(':')
                    var release = parseInt(t[0]);
                    var ver = t[1];
                    if(self.release < release) {
                        self.showPopup(
                            SPLangs.update[self.locale] + ' : ' + ver,
                            SPLangs.download[self.locale],
                            function() {
                                widget.openURL('http://widgets.opera.com/widget/6522');
                            }
                        );
                    }
                }
            }
            xhr.send(null);
    };

    Twippera.showPopup = function(txt, btntxt, func) {
        var self = this;
        var popup = $('popup');
            popup.style.display = 'block';
        var ppmsg = popup.getElementsByTagName('p')[0];
            ppmsg.innerHTML = txt;
        var btn = document.evaluate(
            './div/div/div/div/p/button',
            popup,
            null,
            XPathResult.FIRST_ORDERED_NODE_TYPE,
            null
        ).singleNodeValue;
            btn.addEventListener(
                'click',
                function(){
                    self.hidePopup();
                    if(func) {
                        func();
                    }
                },
                false
            );
        var btnInner = document.evaluate(
            './span/span',
            btn,
            null,
            XPathResult.FIRST_ORDERED_NODE_TYPE,
            null
        ).singleNodeValue;
            btnInner.innerHTML = btntxt;
    };

    Twippera.hidePopup = function() {
        var popup = $('popup');
            popup.style.display = 'none';
    };

window.addEventListener('load', function() {
    preLoadImage([
        'images/loading.gif', 
        'images/icon_throbber.gif',
        'images/icon_star_empty.gif',
        'images/icon_star_full.gif'
    ]);

    Twippera.config.load();
    Twippera.initEvent()
    Twippera.update.check();
},false);
